<?php 
require_once APP_HOME.'/bin/guala/gualaPDF.php';

class GaPDEasyForm extends EasyForm 
{ 
    private $pdf;

    public function getPDFReport($pd_id,$shell_id,$generica)
    {
        global $g_BizSystem;
        $dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_detail");
         //logErr($numPD, "numPD", false);
        $dataObjPD->ResetRules();
        $dataObjPD->SetSearchRule("[Id]='".$pd_id."'");
        $dataSet=$dataObjPD->Fetch();
        $dataSet=$dataSet[0];

        $recId=$dataSet['Id'];
        $this->m_RecordId = $recId;

        // TODO: may consider cache the current record in session
        $this->GetDataObj()->SetActiveRecordId($this->m_RecordId);
        $rec = $this->GetDataObj()->GetActiveRecord();

        // update the record row
        $this->m_DataPanel->SetRecordArr($rec);
        $this->m_ActiveRecord = $rec;
         
        $this->getPDF($generica,$shell_id);
   }
  
    private function getImagenPath($data)
    {
	return "../files/sec_upload/pd_imagen/".trim($data['fld_Id']['data']).".jpg";
    }
   
    public function getPDF($generica,$shell_id)
    {	
        //logErr($generica, "generica", false);
	$this->pdf = new gualaPDF(''); 
	
	$tintasBarnices = array();
        $dataTemp=array();	
	$pos = 0;

        if($shell_id!=0){
            $dataSetPDShell=$this->getPDShell($shell_id);}
        else{
            $dataSetPDShell=$this->getPDShell();
        }
        
        foreach ($dataSetPDShell as $key => $value) {

            $dataTemp[0]=$value; 
            $stringPDShell=$this->renderPDShell($dataTemp);
            $tintasBarnices[$pos]['Title'] = "FORMULAS POR SHELL";
            $tintasBarnices[$pos]['data'] = $stringPDShell;
                      // logErr($this->formCompNames);
            foreach ($this->formCompNames as $key => $elem) {
                    $pos ++;       
                    $string = $this->renderTintaBarniz($key,$elem['dataObj'],$value['Id']);
                    if (!$string)
                            continue;
                    $formObj = BizSystem::ObjectFactory()->GetObject($key);
                    $tintasBarnices[$pos]['Title'] = $formObj->m_Title;
                    $tintasBarnices[$pos]['data'] = $string;    
                 ///logErr($string);      
            }
            $pos ++;    
       }
	        
	$data = $this->getDataRow(-1);

	$imagen = $this->getImagenPath($data);
       
        if($generica)
        {
            //logErr($generica, "entro al generica", true);
            $tpl='pd_detail_generica_pdf.tpl';
            $clientes['data']=$this->renderDataCliente();
            $string = $this->pdf->Render($this, $tpl,
                                    array('data'		   => $data,
                                          'tintasBarnices' => $tintasBarnices,
                                             'clientes'=>$clientes,
                                              'cantFila'       => count($data),
                                              'file_exists'    => file_exists($imagen),
                                              'imagen'         => $imagen,
                                              'widthImagen'    => 506
                                            )
								);
        }else{
            //logErr($generica, "entro al normal", true);
            $tpl='pd_detail_pdf.tpl';
            $string = $this->pdf->Render($this, $tpl,
                                    array('data'		   => $data,
                                          'tintasBarnices' => $tintasBarnices,
                                              'cantFila'       => count($data),
                                              'file_exists'    => file_exists($imagen),
                                              'imagen'         => $imagen,
                                              'widthImagen'    => 506
                                            )
								);
        }
           
	$this->pdf->writeHTML($string, true, false, false, false, '');
	
    $recordSet = $this->FetchData();

        ob_end_clean();
	$this->pdf->Output($recordSet[0]['Id']."_".date('d-m-Y').'.pdf'); 
  }
  
    private $formCompNames = array(
   
      'epd.pd_barniz.form.f_ga_pd_barniz_list' => array(
                        'form' => 'epd.pd_barniz.form.f_ga_pd_barniz_comp_list_pdf',
                                                    'dataObj'=>'epd.pd_barniz.dataobj.d_ga_pd_barniz_pdf',
                        'campoConsulta' => 'pd_barniz_id',
						'tpl' => 'barniz_pdf.tpl'
                     ),   

	'epd.pd_tinta_dl.form.f_ga_pd_tinta_dl_list' => array(
                        'form' => 'epd.pd_tinta_dl.form.f_ga_pd_tinta_dl_comp_list_pdf',
                                                    'dataObj'=>'epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl_pdf',
                        'campoConsulta' => 'pd_tinta_dl_id',
						'tpl' => 'tinta_pdf.tpl'
                     )
	
        );

    public function renderDataCliente()
    {
        $dataObjSoli= BizSystem::ObjectFactory()->GetObject('epd.pd_solicitud.dataobj.d_ga_pd_solicitud_generica_list');      
        $dataObjSoli->ResetRules();
        $recordSoli=$dataObjSoli->Fetch();

         $dataObjCliente= BizSystem::ObjectFactory()->GetObject('crm.clientes.dataobj.d_ga_clientes');
         $dataObjCliente->ResetRules();

         $clientes=array();
         foreach ($recordSoli as $key => $value) {
              $dataObjCliente->ResetRules();
              $dataObjCliente->SetSearchRule("[Id]='".$value['cliente_id']."'");
              $recordCliente=$dataObjCliente->Fetch();
              $clientes[$recordCliente[0]['Id']]=$recordCliente[0]['cliente'];
         }
     
         $formName="epd.pd_solicitud.form.f_ga_pd_solicitud_generica_list";
         $formObj = BizSystem::ObjectFactory()->GetObject($formName);
         $dataSet = $formObj->m_DataPanel->RenderTable($recordSoli);

   if (!count($dataSet['data'])) return;

	foreach ($dataSet['elems'] as $key => &$elem)
	{
        $elem['label'] = strip_tags($elem['label']);
	}
        $dataSet['elems']['fld_Cliente'] = array('element' => '',
                                                                  'label' => 'Cliente',
                                                                  'value' => '');
         for ($i = 0; $i < count($dataSet['data']); $i++){//Hago un ciclo por todas las filas
		foreach ($dataSet['data'][$i] as $key => $campo) {//Hago un ciclo por todos los campos
			$dataSet['data'][$i][$key] = strip_tags($dataSet['data'][$i][$key]);

                }
               $dataSet['data'][$i]['fld_Cliente'] = $clientes[$dataSet['data'][$i]['fld_cliente_id']];//$recordCliente[0]['cliente'];
         }
              //logErr($dataSet, "dataSet-renderDataCliente", true);
   return $string = $this->pdf->Render($this,'pd_clientes_pdf.tpl', array('data'=> $dataSet));
  }

    public  function getPDShell($shell_id=NULL)
    {
     $dataObjPDShell = BizSystem::ObjectFactory()->GetObject('epd.pd.dataobj.d_ga_pd_shell_pdf');
     $dataObjPDShell->ResetRules();   
     $dataObjPDShell->SetSearchRule("[pd_id]='".$this->m_RecordId."'"); 
    //logErr($this->m_RecordId, "this->m_RecordId", false);
     if(is_null($shell_id)==false){

         $dataObjPDShell->SetSearchRule("[shell_id]='".$shell_id."'");     
     }
     $record=$dataObjPDShell->Fetch();

     return $record;
   }
   
    private function renderPDShell($value)
    {
    
    $formName="epd.pd.form.f_ga_pd_shell_list_pdf";
    $formObj = BizSystem::ObjectFactory()->GetObject($formName);
    $dataSet = $formObj->m_DataPanel->RenderTable($value);

   if (!count($dataSet['data'])) return;

	foreach ($dataSet['elems'] as $key => &$elem)
	{
        $elem['label'] = strip_tags($elem['label']);
	}

    for ($i = 0; $i < count($dataSet['data']); $i++){//Hago un ciclo por todas las filas
		foreach ($dataSet['data'][$i] as $key => $campo) //Hago un ciclo por todos los campos
			$dataSet['data'][$i][$key] = strip_tags($dataSet['data'][$i][$key]);

                }
             //   logErr($dataSet, "dataSet-renderPDShell2", true);
   return $string = $this->pdf->Render($this,'pd_shell_pdf.tpl', array('data'=> $dataSet));
  }
  
    private function renderTintaBarniz($formName,$dataObjName,$pd_shell_id)
    {
	    $records=array();
        $formObj = BizSystem::ObjectFactory()->GetObject($formName);
                                                     
        $dataObj= BizSystem::ObjectFactory()->GetObject($dataObjName);
        $dataObj->ResetRules();
        $dataObj->SetSearchRule("[pd_shell_id]='".$pd_shell_id."'");
        $dataObj->SetSortRule('[no_order] ASC');
        $record=$dataObj->Fetch();
                
               
        if($formName=="epd.pd_barniz.form.f_ga_pd_barniz_list")
        {
            if(is_array($record))
            foreach($record as $key=>$val)
            {   
                $val['tipo']=1;
                $records[]=$val;
            }
        
            $dataObj1= BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito_pdf");
            $dataObj1->ResetRules();
            $dataObj1->SetSearchRule("[pd_shell_id]='".$pd_shell_id."'");
            $dataObj1->SetSortRule('[no_order] ASC');
            $record2=$dataObj1->Fetch();
            
            if(is_array($record2))
            foreach($record2 as $key=>$val)
            {   
                $val['tipo']=3;
                $records[]=$val;
            }
             // burbuja
            $cant = count($records);  
            for($i=0;$i<$cant;$i++)
            {
                for($j=$i+1;$j<$cant;$j++)  
                {            
                    $temp='';
                    if($records[$i]['no_order']>$records[$j]['no_order'])
                    {
                        $temp = $records[$i];
                        $records[$i] = $records[$j];
                        $records[$j] = $temp;
                    }
                }
                
            }    
              
            $record=$records;
        }
    
                     //logErr($record,red,false) ;   
        $dataSet = $formObj->m_DataPanel->RenderTable($record);
                   //logErr($dataSet);
	    if (!count($dataSet['data'])) return;
            
	    foreach ($dataSet['elems'] as $key => &$elem)
	    {
            $elem['label'] = strip_tags($elem['label']);
	    }
                    
	    for ($i = 0; $i < count($dataSet['ids']); $i++){//Hago un ciclo por todas las filas		
		    foreach ($dataSet['data'][$i] as $key => $campo) //Hago un ciclo por todos los campos
                $dataSet['data'][$i][$key] = strip_tags($dataSet['data'][$i][$key]);
			    $dataSet['data'][$i]['fld_tipo_id'] = strip_tags($dataSet['data'][$i]['fld_tipo_id']);
                   
                if($dataSet['data'][$i]['fld_tipo_id']!=3)
                    $formObjComp = BizSystem::ObjectFactory()->GetObject($this->formCompNames[$formName]['form']);
                else
			       $formObjComp = BizSystem::ObjectFactory()->GetObject("epd.pd_tinta_lito.form.f_ga_pd_tinta_lito_comp_list_pdf");

			    $idConsulta = $dataSet['ids'][$i];

                if($dataSet['data'][$i]['fld_tipo_id']!=3) 
                    $campoConsulta = $this->formCompNames[$formName]['campoConsulta'];
                else
			        $campoConsulta = 'pd_tinta_lito_id';
        
			    $formObjComp->SetFixSearchRule("[$campoConsulta] = '$idConsulta'");

			    $dataSetComp = $formObjComp->m_DataPanel->RenderTable($formObjComp->FetchDataSet());
                         
			    foreach ($dataSetComp['elems'] as $key => &$elem)
			    {
				    $elem['label'] = strip_tags($elem['label']);
				    
				    if ($key == 'fld_porciento')
					    $dataSet['elems']['fld_porciento']['label'] = $elem['label'];
			    }
			    
			    $dataSet['data'][$i]['fld_porciento'] = 0;

			    for ($k = 0; $k < count($dataSetComp['data']); $k++)
				    foreach ($dataSetComp['data'][$k] as $keyComp => $campoComp) {
				    
					    $dataSetComp['data'][$k][$keyComp] = strip_tags($dataSetComp['data'][$k][$keyComp]);
					    
					    if ($keyComp == 'fld_porciento')
						    $dataSet['data'][$i]['fld_porciento'] += $dataSetComp['data'][$k][$keyComp];
				    }

			    $dataSet['data'][$i]['componentes_data'] = $dataSetComp;
		    }
      ;
	      //logErr($dataSet);
      return $string = $this->pdf->Render($this, $this->formCompNames[$formName]['tpl'], array('data'=> $dataSet,
																		 'tieneComponentes' => count($dataSet['data'])
																	));
  }
  
    private function getDataRow($pd_id)
    {
        if($pd_id!=-1)
        {
            
            global $g_BizSystem;
            $dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_detail");
             //logErr($numPD, "numPD", false);
            $dataObjPD->ResetRules();
            $dataObjPD->SetSearchRule("[Id]='".$pd_id."'");
            $dataSet=$dataObjPD->Fetch();
           
            $dataSet=$dataSet[0];
           
            $recId=$dataSet['Id'];
            $this->m_RecordId = $recId;

            // TODO: may consider cache the current record in session
            $this->GetDataObj()->SetActiveRecordId($this->m_RecordId);
            $rec = $this->GetDataObj()->GetActiveRecord();
            // update the record row
            $this->m_DataPanel->SetRecordArr($rec);
            $this->m_ActiveRecord = $rec;
            
        }
        $recordSet[0] = $this->FetchData();
        $dataSet = $this->m_DataPanel->RenderTable($recordSet);
	$data = array();

	foreach ($dataSet['elems'] as $key => $elem)
	{
		$data[$key]['label'] = $elem['label'];
		$data[$key]['data']  = strip_tags($dataSet['data'][0][$key]);
	}
	
	return $data;
  }

    public function aprobacionPDPDF($num_pd=null)
    {
	require_once('AprobacionPD.php');
        if(is_null($num_pd))
            $num_pd=-1;
	
        $data = $this->getDataRow($num_pd);

    global $g_BizSystem;
	$dataObjPDShell= $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd_shell");    
	if($num_pd!=-1){
            $pd_id=trim($data['fld_Id']['data'])*1;
            $dataObjPDShell->SetSearchRule("[pd_id]='".$pd_id."'");
    }  
        $dataRec=$dataObjPDShell->fetch();     
   //logErr($dataRec, dataRec, false);
        if(count($dataRec)==1)
            $data['fld_shell']=array ('label' => 'shell','data'=>$dataRec[0]['shell']);

	$pdf = new AprobacionPD($data);  
	 ob_end_clean();
        $pdf->SetTitle("Aprobacion de PD");
        $pdf->SetAuthor("Sistema de GUALA");
	$pdf->Output('example_013.pdf', 'I');

    return;
	
  
  }
  
    public function aprobacionPDPDFreport($num_pd)
    {
        $this->aprobacionPDPDF($num_pd);
            global $g_BizSystem;
            $dataObjPD = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd");
             //logErr($numPD, "numPD", false);
            $dataObjPD->ResetRules();
            $dataObjPD->SetSearchRule("[num_pd]='".$num_pd."'");
            $dataSet=$dataObjPD->Fetch();
            $oldRec=$dataSet=$dataSet[0];
            if(PD_WorkFlow=='_it')
            {
                 if($dataSet['estado']==6)
                {
                    $dataSet['estado']=2;
                    $result=$dataObjPD->UpdateRecord($dataSet,$oldRec);
                }
                
            }
            else
            {
                if($dataSet['estado']==6)
                {
                    $dataSet['estado']=2;
                    $result=$dataObjPD->UpdateRecord($dataSet,$oldRec);
                }
            }

  }
  
    public function DeleteRecord($id=null)
	{
	    if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".delete"))
            return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
        
        if ($id==null || $id=='')
            $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        if ($selIds == null)
            $selIds[] = $id;
        foreach ($selIds as $id) {
            $recArray = $this->GetDataObj()->FetchById($id);
            $this->GetDataObj()->SetActiveRecord($recArray);
            $dataRec = new DataRecord($recArray, $this->GetDataObj());
			
			$PD_Id=$dataRec->get('Id');
			$filedir = $this->GetTargetPath().DIRECTORY_SEPARATOR;
			$filepath = $filedir.DIRECTORY_SEPARATOR.$PD_Id.".jpg";		//BizSystem::log(LOG_ERR, 'mensaje', $filepath);
					
			if (file_exists($filepath) ) 
			 {
				$result=unlink($filepath);
					//BizSystem::log(LOG_ERR, 'mensaje', $result);
			 }
			 
            // take care of exception
            try {
                $dataRec->Delete();
            } catch (BDOException $e) {
                // call $this->ProcessBDOException($e);
                $this->ProcessBDOException($e);
                return;
            }
        }
        if ($this->m_FormType == "LIST")
            $this->ReRender();
      
        $this->RunEventLog();
        $this->ProcessPostAction();
	}
    
	private function GetTargetPath()
	{
      return SECURE_UPLOAD_PATH.DIRECTORY_SEPARATOR."pd_imagen";
	}
	 
	public function SaveRecord()
	{
        if ($this->m_FormType != "NEW")
            $currentRec = $this->FetchData(); 
      
       
	   $recArr = $this->ReadInputRecord();

        $this->SetActiveRecord($recArr);
        if (count($recArr) == 0)
            return;
                
        try {
            $this->ValidateForm();
        }
        catch (ValidationException $e) {
			$this->ProcessFormObjError($e->m_Errors);
			return;
        }   
		$d_ga_pd_cliente = BizSystem::ObjectFactory()->GetObject("epd.pd_cliente.dataobj.d_ga_pd_cliente");
        if ($this->m_FormType == "NEW")
        {  
            // check access, if deny, redirect to access deny page
          //  if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".create"))
            //    return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
            $dataRec = new DataRecord(null, $this->GetDataObj());
			$dataRec_PD_Cliente= new DataRecord(null, $d_ga_pd_cliente);
			
		 
        }
        else
        {
            
			$d_ga_pd_cliente->ResetRules();
			$searchRule="[num_pd]='".$currentRec['Id']."'";
			$searchRule.="AND [cliente_id]='".$currentRec['cliente_id']."'";
			$recordList = array();
			$d_ga_pd_cliente->FetchRecords($searchRule,$recordList);
			
			//BizSystem::log(LOG_ERR, 'recordList', var_export($currentRec,true));
           
            $dataRec = new DataRecord($currentRec, $this->GetDataObj());
			if(isset($recordList[0]))
				$dataRec_PD_Cliente= new DataRecord($recordList[0], $d_ga_pd_cliente);
			else
				$dataRec_PD_Cliente= new DataRecord(null, $d_ga_pd_cliente);
        }
         
		//constuyo el objeto GA_PD lleno
        foreach ($recArr as $k => $v)
				$dataRec[$k] = $v;  
         
		//BizSystem::log(LOG_ERR, 'dataRec', var_export($dataRec['generica'],true));return;
		 // construyo el objeto ga_pd_cliente lleno
		$dataRec_PD_Cliente ['cliente_id']=$recArr['cliente_id'];
		$dataRec_PD_Cliente ['num_pd']=$recArr['Id'];
		
           	try { 
                $dataRec->Save();
				if($dataRec['generica']!=1)
				{
				$dataRec_PD_Cliente->Save();
				}
            } 
            catch (ValidationException $e) {
                $errElements = $this->GetErrorElements($e->m_Errors); 
                $this->ProcessFormObjError($errElements);
                return;
            }
            catch (BDOException $e) {
            	$this->ProcessBDOException($e);	
                return;
            }
        
        $this->GetActiveRecord($dataRec["Id"]);
	 
     
        $this->RunEventLog(); 
        // in case of popup form, close it, then rerender the parent form
        if ($this->m_ParentFormName)
        {
            $this->Close();
        
            $this->RenderParent();
        }
       
        $this->ProcessPostAction();
	}
	
	public function FetchData()
    {
		$result=parent::FetchData();
               // logErr($result);
		return $result;
	}

    
	
	
}