<?php 

class f_ga_pd_shell_edit extends EasyForm 
{ 
  
   
   public function SaveRecord()
   {
        $currentRec = $this->FetchData(); 
            
        $recArr = $this->ReadInputRecord();
        $this->SetActiveRecord($recArr);   
        if (count($recArr) == 0)
            return;
        
        try {
            $this->ValidateForm();
        }
        catch (ValidationException $e) {
            $this->ProcessFormObjError($e->m_Errors);
            return;
        }   
        if ($this->m_FormType == "EDIT")
        {
            
            if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".create"))
                return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
            $dataRec = $currentRec;
        }
   
        
        foreach ($recArr as $k => $v)
            $dataRec[$k] = $v; // or $dataRec->$k = $v;
         
         try {
               $result=$this->GetDataObj()->UpdateRecord($dataRec,$currentRec);
              
                if(is_null($result))
                   return;

            } 
            catch (ValidationException $e) {
                $errElements = $this->GetErrorElements($e->m_Errors); 
                $this->ProcessFormObjError($errElements);
                return;
            }
            catch (BDOException $e) {
                $this->ProcessBDOException($e);    
                return;
            }
                                    
          

        
        $this->RunEventLog(); 
        
        $this->ProcessPostAction();
   }
   
   
    protected function ProcessPostAction()
    {
        
        list($redirectPage,$target) = $this->GetRedirectPage();
        if ($redirectPage)
        {
            if($this->m_hasError==false){
                
                if (strpos($redirectPage,"form=") === 0)
                {
                    parse_str($redirectPage, $output);
                    $formName = $output['form'];
                    
                    
                    $param_flds = array();
                    foreach ($output as $key=>$value)
                    {
                        if (substr($key, 0, 4) == "fld:") {
                            $fldName = substr($key, 4);
                            $param_flds[$fldName] = $value;
                        }
                    }
    
                    $this->_showForm($formName, $target, $param_flds);
                }
                else 
                {
                    
                    BizSystem::ClientProxy()->ReDirectPage($redirectPage);
                }
            }
        }
    }
   
    protected function _showForm($formName, $target, $param_flds)
    {
        
        $formObj = BizSystem::ObjectFactory()->GetObject($formName);
        
        foreach($param_flds as $fldName=>$val)
            $formObj->SetFixSearchRule("[$fldName]='$val'");
        
            BizSystem::ClientProxy()->ReDrawForm($this->m_Name, $formObj->Render());
  
            $formObj->ReRenderSubForms();
        
            
    }
        
        
 

}

?>