<?php 
class d_ga_pd_barniz_comp extends BizDataObj
{
    private $dataObjName;
    
	function GetFieldValue($fldname)
	{
		global $g_BizSystem;		
		$value = parent::GetFieldValue($fldname); 
		if ($fldname == 'pd_id' && !$value) { 
			$dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz"); 
			$barniz = $dataObj->FetchById(parent::GetFieldValue('pd_barniz_id'));
			return $barniz['pd_id'];
		}
		
		return $value;
	}
    
    public function DeleteRecord($recArr)
    {                         
           if($recArr['Id']!="")
           {
            $pd_barniz_id=$recArr['pd_barniz_id'];
            $result=parent::DeleteRecord($recArr);
                 
            // if($utilizacion==4)
            $recArr=$this->InsertRecordBarnizCouche($recArr);
            
            $this->UpdatePorciento($pd_barniz_id);
            return $result;
           }
           return;
    }

    public function UpdateRecord($recArr, $oldRec=null)
    {
            $result=true;
            $this->SetActiveRecord($oldRec);

            $result=parent::UpdateRecord($recArr, $oldRec); 
            
            if($recArr['cantidad_m2_formula' ]!==$oldRec['cantidad_m2_formula' ])
            {
            $recArr=$this->InsertRecordBarnizCouche($recArr);
            }
                
            $this->UpdatePorciento($recArr['pd_barniz_id']);
            return $result;

        }                           
        
    public function UpdateRecordBarnizInterior($recArr, $oldRec=null)
    {
            if(isset($recArr['pd_shell_id']))
            {    
            
            $this->dataObjName="epd.pd.dataobj.d_ga_pd_shell";  
            $params=array('Id'=>$recArr['pd_shell_id']); 
            $data_pd_shell=$this->buscarObjetos($params);   //logErr($data_pd_shell,d_ga_pd_shell,false);  
            $dataRec=array();  
            
                if($data_pd_shell)
                {
                $this->dataObjName="erp.barniz_interior.dataobj.d_ga_erp_barniz_interior"; 
                $params=array('barniz_interior_id'=>$recArr['barniz_id'],'shell_id'=>$data_pd_shell[0]['shell_id']); 
                $dataRec=$this->buscarObjetos($params);   
                }
               // logErr($dataRec,d_ga_erp_barniz_acabado,true);        
            }  
            if(isset($dataRec[0]))
            {
                if($recArr['cantidad_aditivo_m2']>$dataRec[0]['cantidad_maxima'])
                    $recArr['cantidad_aditivo_m2']=$dataRec[0]['cantidad_maxima'];
                elseif($recArr['cantidad_aditivo_m2']<$dataRec[0]['cantidad_minima'])
                    $recArr['cantidad_aditivo_m2']=$dataRec[0]['cantidad_minima']; 
                        
                $cantidad_aditivo_hoja=$data_pd_shell[0]['m2']*$recArr['cantidad_aditivo_m2']; 
                if($data_pd_shell[0]['num_tapas']>0)
                    $cantidad_aditivo=($cantidad_aditivo_hoja*1000)/$data_pd_shell[0]['num_tapas'];  
                else
                    $cantidad_aditivo=0;
                 
                 $recArr['cantidad_aditivo']=round($cantidad_aditivo);
            }

            return $recArr;
        }

    public function InsertRecord($recArr)
    { 
            $result=true;
            $pd_barniz=$this->buscarPdBarniz($recArr);

            
            if(isset($pd_barniz['pd_shell_id'])){
                $recArr['pd_shell_id']=$pd_barniz['pd_shell_id'];
                $utilizacion=$pd_barniz['utilizacion'];
                $recArr['utilizacion']=$utilizacion;
            }
      
            $result=parent::InsertRecord($recArr);
            
            $recArr=$this->InsertRecordBarnizCouche($recArr);
                
            $this->UpdatePorciento($recArr['pd_barniz_id']);  
                
            return $result;
        }
        
    public function InsertRecordBarnizCouche($recArr)
    {       
    
            if(isset($recArr['pd_shell_id']))
            {    
            
            $this->dataObjName="epd.pd.dataobj.d_ga_pd_shell";  
            $params=array('Id'=>$recArr['pd_shell_id']); 
            $data_pd_shell=$this->buscarObjetos($params);  // logErr($data_pd_shell,pd_shell,false);
            
            $hoja_m2=$data_pd_shell[0]['m2'];
            if(strpos($hoja_m2,",")!==false)
               $hoja_m2=str_replace(",",".",$hoja_m2);               
            
            $SetSearchRule="[pd_barniz_id]='".$recArr['pd_barniz_id']."'";
            $this->FetchRecords($SetSearchRule,$recordList,-1,0,true,true);   
            $total=0;
            
            if(!isset($recordList[0]['Id'])) $recordList=array();
             
                foreach($recordList as $value){
                    $value['cantidad_m2_formula']=str_replace(",",".",$value['cantidad_m2_formula']);  
                    $total+=$value['cantidad_m2_formula'];   
                }
               
                foreach($recordList as $key=>$value)
                {
                    $OldRec=$value;
                    $dataRec=array();
                    $value['cantidad_m2_formula']=str_replace(",",".",$value['cantidad_m2_formula']);                  
                    
                    if($recArr['utilizacion']==4)
                    {
                        $this->dataObjName="erp.barniz_couches.dataobj.d_ga_erp_barniz_couches"; 
                        $params=array('barniz_couches_id'=>$value['barniz_id']); 
                        $dataRec=$this->buscarObjetos($params);   
                    }
                    elseif($recArr['utilizacion']==3)
                    {
                        $this->dataObjName="erp.barniz_acabado.dataobj.d_ga_erp_barniz_acabado";  //falta wet&wet
                        $params=array('barniz_acabado_id'=>$value['barniz_id'],'shell_id'=>$data_pd_shell[0]['shell_id'],'wetwet'=>$value['wetwet']); 
                        $dataRec=$this->buscarObjetos($params);   
                    }
                    elseif($recArr['utilizacion']==5)
                    {                              
                        $inserto_id=0;
                        $liquido_id=0;
                        $this->dataObjName="epd.pd.dataobj.d_ga_pd_solicitud_barniz_interior"; 
                        $params=array('Id'=>$value['pd_id']); 
                        $dataPdSolicitud=$this->buscarObjetos($params); 
                                
                        if(isset($dataPdSolicitud[0]))
                        {
                           $inserto_id=$dataPdSolicitud[0]['inserto']; 
                           $liquido_id=$dataPdSolicitud[0]['liquido_contiene']; 
                        }
                        
                        $this->dataObjName="erp.barniz_interior.dataobj.d_ga_erp_barniz_interior"; 
                        $params=array('barniz_interior_id'=>$value['barniz_id'],'shell_id'=>$data_pd_shell[0]['shell_id'],'liquido_id'=>$liquido_id, 'inserto_id'=>$inserto_id); 
                 
                        $dataRec=$this->buscarObjetos($params);     
                    }
                    elseif($recArr['utilizacion']==1)
                    {
                        $this->dataObjName="erp.barniz_enganche.dataobj.d_ga_erp_barniz_enganche";
                        $params=array('barniz_enganche_id'=>$value['barniz_id']); 
                        $dataRec=$this->buscarObjetos($params); 
                    }
                    if($total>0)
                        $value['porciento']=round($value['cantidad_m2_formula']*100/$total,4);    
                    else
                       $value['porciento']=100;     
               
                    if(isset($dataRec[0]))
                    {
                        $calculo=($value['porciento']/100)*$dataRec[0]['cantidad_maxima'];
                        $value['cantidad_aditivo_m2']= $calculo>0 ? $calculo :  $value['cantidad_aditivo_m2'];  
           
                        $cantidad_aditivo_hoja=$hoja_m2*$value['cantidad_aditivo_m2']; 
                        if($data_pd_shell[0]['num_tapas']>0)
                            $cantidad_aditivo=($cantidad_aditivo_hoja*1000)/$data_pd_shell[0]['num_tapas'];  
                        else
                            $cantidad_aditivo=0;
                         
                         $value['cantidad_aditivo']=$cantidad_aditivo > 0 ? $cantidad_aditivo :  $value['cantidad_aditivo'];
                    } 
                      
                    $result=parent::UpdateRecord($value,$OldRec);
                    
                    if(!$result)
                        LogErr("Error al registrar :".$value,UpdateBarniz_Com,false);
                }
             
            }
            return $recArr;
        }
        
    protected function UpdatePorciento($id)
    {
            global $g_BizSystem;
            $db = $g_BizSystem->GetDBConnection("gualaerp");
            $sql = "update ga_pd_barniz set porciento =
            (select sum(porciento) from ga_pd_barniz_comp
            where pd_barniz_id = ga_pd_barniz.id
            )
            where ga_pd_barniz.id = '".$id."'"; //logErr($sql,sql,false);
            $rs = $this->exec_select($db,$sql);

        }

    function exec_select($conn,$sql)
	{
	    BizSystem::log(LOG_DEBUG, "Exec Select", "SQL = ".$sql);
        try {
            $rs = $conn->query($sql);
         }
         catch (Exception $e) {
            throw new Exception("Error in query: " . $sql . ". " . $e->getMessage());
            return false;
         }
		 return $rs;
	}
    
    public function buscarObjetos($params=array())
    {
        global $g_BizSystem;
        //busco si existe barniz Engance
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        foreach($params as $k=>$value)
            $dataObj->setSearchRule("[".$k."] = '".$value."'");

        $dataRec=$dataObj->fetch();
        
        if(count($dataRec)>0)
            return $dataRec;
        return false;

    }
    
    public function buscarPdBarniz($recArr)
    {
            global $g_BizSystem;
            $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz");
            $pd_barniz = $dataObj->FetchById($recArr['pd_barniz_id']);
            
            if(count($pd_barniz)>0)
                return $pd_barniz;
            return false;
    }
    
    public function cancularFormulaBarnizAcabado()
    {
        
        return true;
    }
    
     function searchBarnizEnganche($params=array())
    {
        global $g_BizSystem;
        //busco si existe barniz Engance
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        foreach($params as $k=>$value)
            $dataObj->setSearchRule("[".$k."] LIKE '".$value."'");

        $dataRec=$dataObj->fetch();
        
        if(count($dataRec)>0)
            return $dataRec;
        return false;
        
    }
}
