<?php 
require_once APP_HOME.'/bin/pdc/GaPDC.php';
include_once(MODULE_PATH.'/epd/pd/message/ga_pd.msg');

class f_ga_pd_barniz_comp_pdc_list extends EasyForm 
{ 	
    protected $num_pd_barniz;	
    protected $dataObjName;  
    
	public function DeleteRecord($id=null)
	{ 	
		if(isset($_SESSION['num_pd_barniz']))
			$this->num_pd_barniz=$_SESSION['num_pd_barniz'];

		$this->pdc=new GaPDC();
		global $g_BizSystem;

	    if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".delete"))
            return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);
        
        if ($id==null || $id=='')
            $id = BizSystem::ClientProxy()->GetFormInputs('_selectedId');
        
        $selIds = BizSystem::ClientProxy()->GetFormInputs('row_selections', false);
        if ($selIds == null)
            $selIds[] = $id;
        foreach ($selIds as $id) {
            $recArr = $this->GetDataObj()->FetchById($id); //logErr($recArr,rec,true);
			
			if(!is_null($recArr))
				$comprobacion=$this->pdc->comprobarPDC($recArr['pd_id']);
			elseif(!is_null($this->num_pd_barniz))
				$comprobacion=$this->pdc->comprobarPDC($this->num_pd_barniz);
				
			if(!$comprobacion){
			    $modificacionPDEnCursoMessage = $this->GetMessage("MSG_GA_PD_MODIFICACION_PD_EN_CURSO");
                $g_BizSystem->GetClientProxy()->ShowErrorMessage($modificacionPDEnCursoMessage);
			return;
			}
			
			$name="epd.pd_barniz.dataobj.d_ga_pd_barniz_comp";
			
			if(is_null($recArr))
			{
			 $recArr['Id']=$id;
			  $srcDataObj = $g_BizSystem->GetObjectFactory()->GetObject($name); 
                $searchRule="[tabla]='".$srcDataObj->m_MainTable."' 
                    AND [registro_id]='".$recArr['Id']."'";

                $recArray= $this->pdc->BuscarRegistroModificacion($searchRule);  //logErr($recArray, recArray, true);   
                
                if(isset($recArray[0]['pd_id'])) $recArr['pd_id']=$recArray[0]['pd_id']; 
                
                foreach($recArray as $val)
                {
                    if($val['campo']=='pd_barniz_id')
                    {
                    $recArr['pd_barniz_id']=$val['valor'];
                    break;
                    }
                }        //  logErr($recArr);
			$this->pdc->registrarCambioDelete($name,$recArr);
			}
			else{
			//logErr($recArray, 'recArrayNONULL', false);
			$this->pdc->registrarCambioDelete($name,$recArr,$recArr['pd_id']);
			}
            
            
            //extraer listado completo
            $listado=$this->extraerListadoCompleto($recArr['pd_barniz_id']); //logErr($listado,listado,false);
            
            //recalcular los valores
            $this->recalcularFormulas($listado);  //logErr($listado,recalculado,false);
            
            //registroCambioUpdate
            foreach($listado as $value)
            {
                $cambio['Id']=$value['Id'];
                $cambio['cantidad_aditivo']=(string) $value['cantidad_aditivo'];
                $cambio['cantidad_aditivo_m2']=(string)$value['cantidad_aditivo_m2'];
                //$cambio['cantidad_m2_formula']=(string)$value['cantidad_m2_formula'];
                $cambio['porciento']=(string)$value['porciento'];
                
               // logErr($cambio,cambio,false); logErr($recArr['pd_id'], 'pd_id', false);    
               $cambio['estado_cantidad_m2_formula']=$value['estado_cantidad_m2_formula'];    
               
                $this->pdc->registrarCambioUpdate($name,$cambio,$recArr['pd_id'],false,true);  
                unset($cambio); 
            }
            
        }
        //$formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_barniz.form.f_ga_pd_barniz_pdc_list");  
        $formObj = BizSystem::ObjectFactory()->GetObject("epd.pd_colores.form.f_ga_pdc_color_list");   
        BizSystem::ClientProxy()->ReDrawForm($formObj->m_Name,  $formObj->Render()); 
      
        $this->RunEventLog();
        $this->ProcessPostAction();
	}
 
   ///actualizacion de los datos
    
    public function extraerListadoCompleto($compuesto_id)
    {
            $SearchRule="[pd_barniz_id]='".$compuesto_id."'";
            $records=array();
            $this->GetDataObj()->FetchRecords($SearchRule,$records,-1,0,true,true); //logErr($records,record,false);   
            
                        //trato especial
            $name="epd.pd_barniz.dataobj.d_ga_pd_barniz_comp";
            $records=$this->pdc->cargarDataObjUpdate($name,$records,$this->num_pd_barniz); 
            $temp=array();
            
            foreach($records as $item)
            {                      
                if($compuesto_id==$item['pd_barniz_id'])
                    $temp[]=$item;
            } 
             $records=$temp;
             
             unset($temp); 
             
        return $records;
    }  
    
    public function recalcularFormulas(&$formulas)
    {
          if(isset($formulas[0]['pd_shell_id']))
            {    
            
            $this->dataObjName="epd.pd.dataobj.d_ga_pd_shell";  
            $params=array('Id'=>$formulas[0]['pd_shell_id']); 
            $data_pd_shell=$this->buscarObjetos($params);    //logErr($data_pd_shell,shell,false);

            $hoja_m2=$data_pd_shell[0]['m2'];
            if(strpos($hoja_m2,",")!==false)
               $hoja_m2=str_replace(",",".",$hoja_m2);       
           
            $total=0; 
            if(!isset($formulas[0]['Id'])) $formulas=array();  

            foreach($formulas as $val)
               $total+=$val['cantidad_m2_formula'];
                
            
            foreach($formulas as $key=>&$value)
            {      //logErr($value,antes,false); 
                $OldRec=$value;
                $dataRec=array();                   
                
                if($total>0)
                    $value['porciento']=round($value['cantidad_m2_formula']*100/$total,2);    
                else
                   $value['porciento']=100;
                        
            
                if($value['utilizacion']==4)
                {
                    $this->dataObjName="erp.barniz_couches.dataobj.d_ga_erp_barniz_couches"; 
                    $params=array('barniz_couches_id'=>$value['barniz_id']); 
                    $dataRec=$this->buscarObjetos($params);   
                }
                elseif($value['utilizacion']==3)
                {
                    $this->dataObjName="epd.pd.dataobj.d_ga_pd_solicitud_barniz_interior"; 
                    $params=array('Id'=>$value['pd_id']); 
                    $dataPdSolicitud=$this->buscarObjetos($params); 
                     $wet=0;
                            
                    if(isset($dataPdSolicitud[0]))
                    {
                       $wet=$dataPdSolicitud[0]['wetwet']; 
                     
                    }
                    
                    $this->dataObjName="erp.barniz_acabado.dataobj.d_ga_erp_barniz_acabado";  //falta wet&wet
                    $params=array('barniz_acabado_id'=>$value['barniz_id'],'shell_id'=>$data_pd_shell[0]['shell_id'],'wetwet'=>$wet); 
                    $dataRec=$this->buscarObjetos($params);   
                }
                elseif($value['utilizacion']==5)
                {                              
                    $inserto_id=0;
                    $liquido_id=0;
                    $this->dataObjName="epd.pd.dataobj.d_ga_pd_solicitud_barniz_interior"; 
                    $params=array('Id'=>$value['pd_id']); 
                    $dataPdSolicitud=$this->buscarObjetos($params); 
                            
                    if(isset($dataPdSolicitud[0]))
                    {
                       $inserto_id=$dataPdSolicitud[0]['inserto']; 
                       $liquido_id=$dataPdSolicitud[0]['liquido_contiene']; 
                    }
                    
                    $this->dataObjName="erp.barniz_interior.dataobj.d_ga_erp_barniz_interior"; 
                    $params=array('barniz_interior_id'=>$value['barniz_id'],'shell_id'=>$data_pd_shell[0]['shell_id'],'liquido_id'=>$liquido_id, 'inserto_id'=>$inserto_id); 

                    $dataRec=$this->buscarObjetos($params);     
                }
                elseif($value['utilizacion']==1)
                {
                    $this->dataObjName="erp.barniz_enganche.dataobj.d_ga_erp_barniz_enganche";
                    $params=array('barniz_enganche_id'=>$value['barniz_id']); 
                    $dataRec=$this->buscarObjetos($params); 
                }
                     
                   //  logErr($dataRec[0],data,false);                    
                     if(isset($dataRec[0]))
                     {
                        $cantidad_maxima=$dataRec[0]['cantidad_maxima'];
                        if(strpos($cantidad_maxima,",")!==false)
                            $cantidad_maxima=str_replace(",",".",$cantidad_maxima);
                            
                        $calculo=round(($value['porciento']/100)*$cantidad_maxima,2);
                        $value['cantidad_aditivo_m2']=  $calculo;  
           
                        $cantidad_aditivo_hoja=$hoja_m2*$value['cantidad_aditivo_m2']; 
                        if($data_pd_shell[0]['num_tapas']>0)
                            $cantidad_aditivo=round( ($cantidad_aditivo_hoja*1000)/$data_pd_shell[0]['num_tapas'],2);  
                        else
                            $cantidad_aditivo=0;
                         
                         $value['cantidad_aditivo']=$cantidad_aditivo;
                         }    
                    
                   // logErr($value,despues,false); 
                } 
            }
        
    }
    
     public function buscarObjetos($params=array())
    {
        global $g_BizSystem;
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        foreach($params as $k=>$value)
            $dataObj->setSearchRule("[".$k."] = '".$value."'");

        $dataRec=$dataObj->fetch();
        
        if(count($dataRec)>0)
            return $dataRec;
        return false;

    }
    
    public function buscarPdBarniz($recArr)
    {
            global $g_BizSystem;
            $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_barniz.dataobj.d_ga_pd_barniz");
            $pd_barniz = $dataObj->FetchById($recArr['pd_barniz_id']);
            
            if(count($pd_barniz)>0)
                return $pd_barniz;
            return false;
    }
    
 
}

?>