<?php 
include_once(MODULE_PATH.'/epd/pd_solicitud/message/ga_pd_solicitud.msg');  
class f_ga_pd_solicitud_edit extends EasyForm 
{ 
    
    public function SaveRecord()
    {
    $recArr = $this->ReadInputRecord();
    if(isset($recArr['Id']))
    $currentRec=$this->GetDataObj()->FetchById($recArr['Id']);
    else
    $currentRec = $this->FetchData();
    
    $this->SetActiveRecord($recArr);   
    if (count($recArr) == 0)
    return;

    try {
        $this->validarSustiyeA($recArr);
    }
    catch (ValidationException $e) {
    $this->ProcessFormObjError($e->m_Errors);
    return;
    }   


    // check access, if deny, redirect to access deny page
    if ($this->m_Resource != "" && !$this->AllowAccess($this->m_Resource.".update"))
        return BizSystem::ClientProxy()->RedirectView(ACCESS_DENIED_VIEW);

    $dataRec = new DataRecord($currentRec, $this->GetDataObj());


    foreach ($recArr as $k => $v)
    $dataRec[$k] = $v; // or $dataRec->$k = $v;
     
       try {
        $dataRec->Save();
        if($currentRec['sustituye_num_pd']!=$recArr['sustituye_num_pd'])
            $this->aplicarSustitucionPD($recArr);
    } 
    catch (ValidationException $e) {
        $errElements = $this->GetErrorElements($e->m_Errors); 
        $this->ProcessFormObjError($errElements);
        return;
    }
    catch (BDOException $e) {
        $this->ProcessBDOException($e);    
        return;
    }
                            
    $this->GetActiveRecord($dataRec["Id"]);   

    if($dataRec['num_pd'] && $dataRec['num_pd']>1)
    {
    $texto=$this->GetMessage("MSG_GA_PD_SOLICITUD_DATA_UPDATE_CORRECT",array($ok)); 
    BizSystem::ClientProxy()->ShowClientAlert($texto);
    }

    $this->RunEventLog(); 

    $this->ProcessPostAction();
    }

    public function aplicarSustitucionPD($recArr=array())
    {
    if(isset($recArr['sustituye_num_pd']) && $recArr['sustituye_num_pd']!="" && $recArr['sustituye_num_pd']>0)
    {                         // logErr($recArr['sustituye_num_pd'],sustituye_num_pd,false);    
    $dataObjPD = BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd");   
    $dataObjPD->setSearchRule("[num_pd]='".$recArr['sustituye_num_pd']."'");  
    $dataRec=$dataObjPD->fetch();
                                                // logErr($dataRec);
    if(isset($dataRec[0]['Id']) )
    {
    $oldDataRec=$dataRec=$dataRec[0];
                                              //logErr($oldDataRec,oldDataRec,false);  
    $dataRec['estado']=4;
    $dataRec['fecha_anulacion']=date("d-m-Y");
    $dataRec['anulada']=1;
                                           //logErr($dataRec,dataRec,false);  
    $result=$dataObjPD->UpdateRecord($dataRec,$oldDataRec);
      // logErr($result,result,false);  
    }
    }

    return;

    }

    public function validarSustiyeA($recArr=array())
    {                
    $this->ValidateForm();
                 //logErr($recArr['sustituye_num_pd'],sustituye_num_pd,false); 
    if(isset($recArr['sustituye_num_pd']) && $recArr['sustituye_num_pd']>0)
    { 
                //logErr($recArr['sustituye_num_pd']); 
         
    $bizFld = $this->GetDataObj()->m_BizRecord->get('sustituye_num_pd');    
    if($recArr['sustituye_num_pd']!==null && $bizFld->CheckValueType($recArr['sustituye_num_pd']) === false)
    {
      $this->m_ErrorMessage = $this->GetMessage("DATA_FIELD_INCORRECT_TYPE",array("fld_sustituye_num_pd", $bizFld->m_Type));
      $this->m_ValidateErrors["fld_sustituye_num_pd"] = $this->m_ErrorMessage; 
             // logErr( $this->m_ErrorFields);
    }else
    {
           // logErr($bizFld);
    $dataObjPD = BizSystem::GetObjectFactory()->GetObject("epd.pd.dataobj.d_ga_pd");   
    $dataObjPD->setSearchRule("[num_pd]='".$recArr['sustituye_num_pd']."'");  
    $dataRec=$dataObjPD->fetch();

    if( $recArr['num_pd']==$recArr['sustituye_num_pd'])
    {
      $errorMessage = $this->GetMessage("MSG_GA_PD_SOLICITUD_DATA_MISMO_NUM_PD_SUSTITUYE",array($recArr['sustituye_num_pd']));  
      $this->m_ValidateErrors["fld_sustituye_num_pd"] = $errorMessage;
    }
    elseif(!isset($dataRec[0]['Id']) || $dataRec[0]['num_pd']!=$recArr['sustituye_num_pd'])
    {
      $errorMessage = $this->GetMessage("MSG_GA_PD_SOLICITUD_DATA_NOT_NUM_PD_SUSTITUYE",array($recArr['sustituye_num_pd']));  
      $this->m_ValidateErrors["fld_sustituye_num_pd"] = $errorMessage;
    }
    }


    if (count($this->m_ValidateErrors) > 0)
    {             
    throw new ValidationException($this->m_ValidateErrors);
    return false;
    }

    }
    return true;  
    }

    protected function ValidateForm()
    {
    $this->m_ValidateErrors = array();
    $this->m_DataPanel->rewind();

    while($this->m_DataPanel->valid()){                
    $elem=$this->m_DataPanel->current();
    if($elem->m_Label){
    $elem_name = $elem->m_Label;
    }else{
    $elem_name = $elem->m_Text;
    }   
    if($elem->m_BlankOption){  
    if($elem->m_Value==-1 && $elem->CheckRequired() === true){
        $errorMessage = $this->GetMessage("DATA_FIELD_REQUIRED",array($elem_name));
        $this->m_ValidateErrors[$elem->m_Name] = $errorMessage;
       
        }
    }
    if ($elem->CheckRequired() === true &&
     ($elem->m_Value===null || $elem->m_Value === "")) {
    //logErr($elem, 'elem', false);
    $errorMessage = $this->GetMessage("DATA_FIELD_REQUIRED",array($elem_name));
    $this->m_ValidateErrors[$elem->m_Name] = $errorMessage;  

    }         
    else if ($elem->m_Value!==null && $elem->Validate() === false) {
    GLOBAL $g_BizSystem;            
    $srvcObj = $g_BizSystem->GetService(VALIDATE_SERVICE);
    $errorMessage = $srvcObj->GetErrorMessage($elem->m_Validator, $elem_name);            
    if ($errorMessage == false) { //Couldn't get a clear error message so let's try this
       $errorMessage = $this->GetMessage("FORM_ELEMENT_INVALID_INPUT",array($elem_name));
    }
    $this->m_ValidateErrors[$elem->m_Name] = $errorMessage; 
    //return false;
    } 
    $this->m_DataPanel->next() ;
    }

    if (count($this->m_ValidateErrors) > 0)
    {             
    throw new ValidationException($this->m_ValidateErrors);
    return false;
    }
    return true;
    }
    
    
  
}