<?php 
class d_ga_pd_tinta_dl_comp extends BizDataObj
{
	function GetFieldValue($fldname)
	{
		global $g_BizSystem;
		
		$value = parent::GetFieldValue($fldname);
		
		if ($fldname == 'pd_id' && !$value) {
		
			$dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl");
			
			$tinta_dl = $dataObj->FetchById(parent::GetFieldValue('pd_tinta_dl_id'));
			
			return $tinta_dl['pd_id'];
		}
		
		return $value;
	}
    
    public function DeleteRecord($recArr)
    {
        if($recArr['Id']!="")
        {
        $pd_tinta_dl_id=$recArr['pd_tinta_dl_id'];
        $result=parent::DeleteRecord($recArr);
        
        $this->InsertRecordTintaDL($recArr);  
        
        $this->UpdatePorciento($pd_tinta_dl_id);
        return $result;
        }
       return;
    }

     public function UpdateRecord($recArr, $oldRec=null)
    {
		$this->SetActiveRecord($oldRec);
                     
        $result=parent::UpdateRecord($recArr, $oldRec);
                                  
        if($recArr['cantidad_m2_formula' ]!==$oldRec['cantidad_m2_formula' ])
        {
        $this->InsertRecordTintaDL($recArr);  
        }

        $this->UpdatePorciento($recArr['pd_tinta_dl_id']);
        return $result;
    }

    public function InsertRecord($recArr)
    {
        $result=true;
        $pd_tinta_dl=$this->buscarPdTintaDL($recArr);
        
        
        if(isset($pd_tinta_dl['utilizacion'])){
            $recArr['pd_shell_id']=$pd_tinta_dl['pd_shell_id'];
            $recArr['utilizacion']=$pd_tinta_dl['utilizacion'];
        }
               //  logErr($recArr,recARr,true);  
        $result=parent::InsertRecord($recArr);
             // logErr($result,result,false);    
        $this->InsertRecordTintaDL($recArr);
        
        $this->UpdatePorciento($recArr['pd_tinta_dl_id']);
        return $result;
    }
        
    public function InsertRecordTintaDL($recArr)
    {            
         
        if(isset($recArr['pd_shell_id']))
        {    
        
        $this->dataObjName="epd.pd.dataobj.d_ga_pd_shell";  
        $params=array('Id'=>$recArr['pd_shell_id']); 
        $data_pd_shell=$this->buscarObjetos($params);      
        $dataRec=array();  
        
        if($recArr['utilizacion']==1)
        {
            $this->dataObjName="erp.tinta_dl_serigrafia.dataobj.d_ga_erp_tinta_serigrafia"; 
            $params=array('shell_id'=>$data_pd_shell[0]['shell_id']);   
            $dataRec=$this->buscarObjetos($params); 
            if(!isset($dataRec[0])) logErr("para la shell:".$data_pd_shell[0]['shell_id']."No encontro d_ga_erp_tinta_serigrafia", d_ga_erp_tinta_serigrafia,false);   
        }
        
        $SetSearchRule="[pd_tinta_dl_id]='".$recArr['pd_tinta_dl_id']."'";   
        $this->FetchRecords($SetSearchRule,$recordList ,-1,0,true,true);   
        
        $total=0; 
        if(!isset($recordList[0]['Id'])) $recordList=array();  

        foreach($recordList as $value){
            $value['cantidad_m2_formula']=str_replace(",",".",$value['cantidad_m2_formula']);  
           $total+=$value['cantidad_m2_formula'];
        }
            
        foreach($recordList as $key=>$value)
        {
            $value['cantidad_m2_formula']=str_replace(",",".",$value['cantidad_m2_formula']);
            $OldRec=$value;                    
            if($total>0)
                $value['porciento']=round($value['cantidad_m2_formula']*100/$total,4);    
            else
               $value['porciento']=100;  
                       
            
            if($value['utilizacion']==2)
            {
                $this->dataObjName="erp.tinta_dl_offset.dataobj.d_ga_erp_tinta_offset"; 
                $params=array('shell_id'=>$data_pd_shell[0]['shell_id'],'utilizacion'=>$value['tipo_offset']);   
                $dataRec=$this->buscarObjetos($params);   
                if(!isset($dataRec[0])) logErr("para la shell:".$data_pd_shell[0]['shell_id']." y utilizacion=>".$value['tipo_offset']."No encontro d_ga_erp_tinta_offset", errord_ga_erp_tinta_offse,false);
            }
             elseif($value['utilizacion']==3)
            {
                $this->dataObjName="erp.barniz_esmalte.dataobj.d_ga_erp_barniz_esmalte"; 
                $params=array('barniz_esmalte_id'=>$value['tinta_id']);   
                $dataRec=$this->buscarObjetos($params);    
                if(!isset($dataRec[0])) logErr("para la barniz_esmalte_id:".$value['tinta_id']."No encontro d_ga_erp_barniz_esmalte", errord_ga_erp_barniz_esmalte,false);
            }
            
                   // logErr($dataRec[0],data,false);                    
                    if(isset($dataRec[0]) && $value['utilizacion']==1)
                    {

                      $cantidad_aditivo=$dataRec[0]['cantidad_1000_tapas'];       
                         
                      $value['cantidad_aditivo']=$cantidad_aditivo > 0 ? ($cantidad_aditivo*$value['porciento']/100) :  $value['cantidad_aditivo'];
         
                      $calculo=$cantidad_aditivo * $data_pd_shell[0]['num_tapas'] / 1000;
                      
                      $hoja_m2=$data_pd_shell[0]['m2'];
                      if(strpos($hoja_m2,",")!==false)
                           $hoja_m2=str_replace(",",".",$hoja_m2); 
                                      
                      if($calculo>0 && $hoja_m2 >0){
                      
                        $value['cantidad_aditivo_m2']= $calculo/$hoja_m2; 
                        $value['cantidad_aditivo_m2']=$value['cantidad_aditivo_m2']*$value['porciento']/100;
                      }          
                    
                    } elseif(isset($dataRec[0]) && $value['utilizacion']==3)
                    {

                      $cantidad_aditivo=$dataRec[0]['cantidad_maxima'];       
                         
                      $value['cantidad_aditivo']=$cantidad_aditivo > 0 ? ($cantidad_aditivo*$value['porciento']/100) :  $value['cantidad_aditivo'];
         
                      $calculo=$cantidad_aditivo * $data_pd_shell[0]['num_tapas'] / 1000;
                      
                      $hoja_m2=$data_pd_shell[0]['m2'];
                      if(strpos($hoja_m2,",")!==false)
                           $hoja_m2=str_replace(",",".",$hoja_m2); 
                                      
                      if($calculo>0 && $hoja_m2 >0){
                      
                        $value['cantidad_aditivo_m2']= $calculo/$hoja_m2; 
                        $value['cantidad_aditivo_m2']=$value['cantidad_aditivo_m2']*$value['porciento']/100;
                      }          
                    
                    }
                    elseif(isset($dataRec[0]) && $value['utilizacion']==2)
                    {
                    
                    $cantidad_aditivo=$dataRec[0]['cantidad'];       
                         
                      $value['cantidad_aditivo']=$cantidad_aditivo > 0 ? ($cantidad_aditivo*$value['porciento']/100) :  $value['cantidad_aditivo'];
         
                      $calculo=$cantidad_aditivo * $data_pd_shell[0]['num_tapas'] / 1000; 
                      
                      $hoja_m2=$data_pd_shell[0]['m2'];
                      if(strpos($hoja_m2,",")!==false)
                           $hoja_m2=str_replace(",",".",$hoja_m2); 
                           
                      if($calculo>0 && $hoja_m2 >0){                      
                        $value['cantidad_aditivo_m2']= $calculo/$hoja_m2; 
                        $value['cantidad_aditivo_m2']=$value['cantidad_aditivo_m2']*$value['porciento']/100;
                      }
                    }  
                
                    $result=parent::UpdateRecord($value,$OldRec);
                    
                    if(!$result)
                        LogErr("Error al registrar :".$value,UpdateTintaDL_Comp,false);
                
            } 
        }

        return $recArr;
    }
        
    public function buscarPdTintaDL($recArr)
    {
        global $g_BizSystem;
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_tinta_dl.dataobj.d_ga_pd_tinta_dl");
        $pd_tinta_lito = $dataObj->FetchById($recArr['pd_tinta_dl_id']);
        
        if(count($pd_tinta_lito)>0)
            return $pd_tinta_lito;
        return false;
      }
    
    public function buscarObjetos($params=array())
    {
        global $g_BizSystem;
        //busco si existe barniz Engance
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        foreach($params as $k=>$value)
            $dataObj->setSearchRule("[".$k."] = '".$value."'");

        $dataRec=$dataObj->fetch();
        
        if(count($dataRec)>0)
            return $dataRec;
        return false;

    }
        
    protected  function UpdatePorciento($id)
    {
        global $g_BizSystem;
        $db = $g_BizSystem->GetDBConnection("gualaerp");
        $sql = "update ga_pd_tinta_dl set porciento =
            (select sum(porciento) from ga_pd_tinta_dl_comp
            where pd_tinta_dl_id = ga_pd_tinta_dl.id
            )
            where ga_pd_tinta_dl.id ='".$id."'";
        $rs = $this->exec_select($db,$sql);

    }

    function exec_select($conn,$sql)
    {
        BizSystem::log(LOG_DEBUG, "Exec Select", "SQL = ".$sql);
        try {
        $rs = $conn->query($sql);
        }
        catch (Exception $e) {
        throw new Exception("Error in query: " . $sql . ". " . $e->getMessage());
        return false;
        }
        return $rs;
    }
}