<?php 
class d_ga_pd_tinta_lito_comp extends BizDataObj
{
    private $dataObjName;
    
	function GetFieldValue($fldname)
	{
		global $g_BizSystem;
		
		$value = parent::GetFieldValue($fldname);
		
		if ($fldname == 'pd_id' && !$value) {
		
			$dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito");
			
			$tita_lito = $dataObj->FetchById(parent::GetFieldValue('pd_tinta_lito_id'));
			//logErr($tita_lito, "tita_lito", false);
			return $tita_lito['pd_id'];
		}
		
		return $value;
	}

    public function DeleteRecord($recArr)
    {
            if($recArr['Id']!="")
            {
            $pd_tinta_litos_id=$recArr['pd_tinta_lito_id'];
            $result=parent::DeleteRecord($recArr);

            $recArr=$this->InsertRecordTintaLito($recArr);   
            $this->UpdatePorciento($pd_tinta_litos_id);
            return $result;
            
            }
           return;
        }

     public function UpdateRecord($recArr, $oldRec=null)
    {
		$this->SetActiveRecord($oldRec); 
    
        $result=parent::UpdateRecord($recArr, $oldRec);

        if($recArr['cantidad_m2_formula' ]!==$oldRec['cantidad_m2_formula' ])
        {
        $recArr=$this->InsertRecordTintaLito($recArr);  
        }

        $this->UpdatePorciento($recArr['pd_tinta_lito_id']);
        return $result;
    }

    public function InsertRecord($recArr)
    {
            $result=true;
            $pd_tinta_lito=$this->buscarPdTintaLito($recArr);
            
            if(isset($pd_tinta_lito['utilizacion'])){
                $recArr['pd_shell_id']=$pd_tinta_lito['pd_shell_id'];
                $recArr['utilizacion']=$pd_tinta_lito['utilizacion'];
            }
            
        $result=parent::InsertRecord($recArr);
        
        $recArr=$this->InsertRecordTintaLito($recArr);   
                   
        $this->UpdatePorciento($recArr['pd_tinta_lito_id']);
        return $result;
    }
    
    public function InsertRecordTintaLito($recArr)
    {            
             
            if(isset($recArr['pd_shell_id']))
            {    
            
            $this->dataObjName="epd.pd.dataobj.d_ga_pd_shell";  
            $params=array('Id'=>$recArr['pd_shell_id']); 
            $data_pd_shell=$this->buscarObjetos($params);   
            $dataRec=array();  
            
            $hoja_m2=$data_pd_shell[0]['m2'];
            if(strpos($hoja_m2,",")!==false)
                   $hoja_m2=str_replace(",",".",$hoja_m2); 
            
            $this->dataObjName="erp.tinta_lito_cantidad_tipo.dataobj.d_ga_erp_tinta_lito_catidad_tipo"; 
            $params=array('utilizacion'=>$recArr['utilizacion'],'shell_id'=>$data_pd_shell[0]['shell_id']); 
            $dataRec=$this->buscarObjetos($params);        //logErr();
             if(!isset($dataRec[0])) logErr("para la shell:".$data_pd_shell[0]['shell_id']." y utilizacion :".$recArr['utilizacion']."No encontro d_ga_erp_tinta_lito_catidad_tipo", d_ga_erp_tinta_lito_catidad_tipo,false);   
            
            $SetSearchRule="[pd_tinta_lito_id]='".$recArr['pd_tinta_lito_id']."'";  // logErr($SetSearchRule,busqueda,false);      
            $this->FetchRecords($SetSearchRule,$recordList ,-1,0,true,true);  
            $total=0; 
            if(!isset($recordList[0]['Id'])) $recordList=array();  

                foreach($recordList as $value){
                   $value['cantidad_m2_formula']=str_replace(",",".",$value['cantidad_m2_formula']);
                   $total+=$value['cantidad_m2_formula'];
                }
                
                foreach($recordList as $key=>$value)
                {
                    $value['cantidad_m2_formula']=str_replace(",",".",$value['cantidad_m2_formula']);
                    $OldRec=$value;                    
                    if($total>0)
                       $value['porciento']=round($value['cantidad_m2_formula']*100/$total,4);    
                    else
                       $value['porciento']=100;        

 
                    if(isset($dataRec[0]))
                    {                            
                        $calculo =($value['porciento']/100)*$dataRec[0]['cantidad_m2'];
                        $value['cantidad_aditivo_m2']=$calculo>0 ? $calculo :  $value['cantidad_aditivo_m2'];  
                         
                        $value['cantidad_aditivo']=$dataRec[0]['cantidad_1000_tapas'] > 0 ? $dataRec[0]['cantidad_1000_tapas']*($value['porciento']/100) :  $value['cantidad_aditivo'];
                    } 
                    

                    $result=parent::UpdateRecord($value,$OldRec);
                    
                    if(!$result)
                        LogErr("Error al registrar :".$value,UpdateTintaLito_Com,false);
                
                } 
            }
              
            return $recArr;
        }
        
    public function buscarObjetos($params=array())
    {
        global $g_BizSystem;
        //busco si existe barniz Engance
        $dataObj = $g_BizSystem->GetObjectFactory()->GetObject($this->dataObjName);
        if (!$dataObj) return false;
        $dataObj->ResetRules();

        foreach($params as $k=>$value)
            $dataObj->setSearchRule("[".$k."] = '".$value."'");

        $dataRec=$dataObj->fetch();
        
        if(count($dataRec)>0)
            return $dataRec;
        return false;

    }
    
     public function buscarPdTintaLito($recArr)
    {
            global $g_BizSystem;
            $dataObj = $g_BizSystem->GetObjectFactory()->GetObject("epd.pd_tinta_lito.dataobj.d_ga_pd_tinta_lito");
            $pd_tinta_lito = $dataObj->FetchById($recArr['pd_tinta_lito_id']);
            
            if(count($pd_tinta_lito)>0)
                return $pd_tinta_lito;
            return false;
    }
    
    protected  function UpdatePorciento($id)
    {
            global $g_BizSystem;
            $db = $g_BizSystem->GetDBConnection("gualaerp");
            $sql = "update ga_pd_tinta_lito set porciento =
                (select sum(porciento) from ga_pd_tinta_lito_comp
                where pd_tinta_lito_id = ga_pd_tinta_lito.id
                )
                where ga_pd_tinta_lito.id ='".$id."'";
            $rs = $this->exec_select($db,$sql);

        }

    function exec_select($conn,$sql)
	{
	 BizSystem::log(LOG_DEBUG, "Exec Select", "SQL = ".$sql);
        try {
            $rs = $conn->query($sql);
         }
         catch (Exception $e) {
            throw new Exception("Error in query: " . $sql . ". " . $e->getMessage());
            return false;
         }
		 return $rs;
	}
}