<?php 

class f_ga_pd_list_report_pendiente_desarrollo extends EasyForm
{
	private $sumaDias = 0;
	private $cantidad = 1;
	
    public function OutputAttrs()
	{
        global $g_BizSystem;        
        $dateService = $g_BizSystem->GetService('dateService');
		$output = parent::OutputAttrs();
		 $serachRule="";                 
         
        $result = $this->GetDataObj()->DirectFetch($serachRule);
        $this->cantidad=$this->GetDataObj()->Count(); 
        
        foreach($result as $key=>$value)
        {
            $difDias = $dateService->restaFechas($value['fecha_solicitud'], date('d-m-Y'));
            $this->sumaDias += $difDias;
            $value['dias']=$difDias;
        }
		$output['count']       = $this->cantidad;
        
		if($this->cantidad!=0)
			$plazo_medio = $this->sumaDias/$this->cantidad;
		else
			$plazo_medio=0;
                $output['plazo_medio'] = number_format($plazo_medio, 2, '.', '');
		return $output;
	}
      
	public function FetchDataSet()
    {
                global $g_BizSystem;        
        $dateService = $g_BizSystem->GetService('dateService');
	  
	 $result=parent::FetchDataSet();
	  
     foreach($result as &$value)
     {
        $filename="../files/sec_upload/pd_imagen/".$value['Id'].".jpg";

        if(!file_exists($filename))
        {
            $value['image']="";
        }
           $difDias = $dateService->restaFechas($value['fecha_solicitud'], date('d-m-Y'));
            $value['dias']=$difDias;

	}	 
	return $result;

	 }

   public function RunSearch()
    {
        include_once(OPENBIZ_BIN."/easy/SearchHelper.php");
        $searchRule = "";$cadena=array();
                $fecha_desde=null; 
        $fecha_hasta=null;
        foreach ($this->m_SearchPanel as $k=>$elem) 
        {
            if (!$elem->m_FieldName)
                continue;
            
            $value = BizSystem::ClientProxy()->GetFormInputs($elem->m_Name);
            $bizField = $this->GetDataObj()->GetField($elem->m_FieldName);     
   
    
             $cadena[$elem->m_FieldName]=$value;    
             $activo=true;  
             if($elem->m_BlankOption && strpos($elem->m_BlankOption,'-1') && $value==-1)
                  $activo=false;  
             if($elem->m_Name=="qry_fecha_inicio" && $value){
                   $fecha_desde=split("-",$value);       
                   if(count($fecha_desde))
                   $value=$fecha_desde[2]."-".$fecha_desde[1]."-".$fecha_desde[0] ;
                   $fecha_desde = "CONVERT(datetime, '".$value." 00 :00 :00"."', 102)";     
                   continue;  
             } 
             if($elem->m_Name=="qry_fecha_fin" && $value){ 
                   $fecha_hasta=split("-",$value);                          
                   if(count($fecha_hasta))
                   $value=$fecha_hasta[2]."-".$fecha_hasta[1]."-".$fecha_hasta[0] ;
                    $fecha_hasta = "CONVERT(datetime, '".$value." 23 :59 :59.997"."', 102)";  
                    continue;     
             }   
            if($elem->m_FuzzySearch=="Y" && $value!=''){
                $value="*$value*";
            }
            if ($value && $activo) {
                $searchStr = InputValToRule($elem->m_FieldName, $value, $this);
                if ($searchRule == "")
                   $searchRule .= $searchStr;
                else
                   $searchRule .= " AND " . $searchStr;
            }
        } 
        $fecha_hoy = "CONVERT(datetime, '".date('Y-m-d')." 00 :00 :00"."', 102)"; 
        
        if($fecha_desde && $fecha_hasta)
        {
          if($searchRule)
            $searchRule.=" AND [fecha_solicitud_entrega] BETWEEN ".$fecha_desde." AND ".$fecha_hasta;
          else
            $searchRule.="[fecha_solicitud_entrega] BETWEEN ".$fecha_desde." AND ".$fecha_hasta;  
        }       
        $this->m_SearchRule = $searchRule;  // logErr($searchRule,searchRule,true);
        $this->m_SearchRuleBindValues = QueryStringParam::GetBindValues();
        $this->setAtributosSearch($cadena,true);
        $this->m_RefreshData = true;

        $this->m_CurrentPage = 1;
        $this->guardarCurrentPage();
        
        BizSystem::log(LOG_DEBUG,"FORMOBJ",$this->m_Name."::RunSearch(), SearchRule=".$this->m_SearchRule);
        
        $this->RunEventLog();
        $this->ReRender();
    }

    public function CallService($class, $method)
    {
       global $g_BizSystem;
       $svcobj = $g_BizSystem->GetService($class);  //logErr(CallService,CallService,false);
     
       $svcobj->renderXSL($this->m_Name,true,true);
    }    

    public function getAtributoFecha($estado)
    {
 
            switch ($estado){
            case 1: return "fecha_solicitud";

            case 2: return "fecha_envio";

            case 3:
                return "fecha_aprobacion";
            case 4:
                return "fecha_anulacion";
            case 5:
                return false;
            default:
                return false;
            }
        }
}
	